const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const candidates = sequelize.define(
    'candidates',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      name: {
        type: DataTypes.TEXT,
      },

      email: {
        type: DataTypes.TEXT,
      },

      phone: {
        type: DataTypes.TEXT,
      },

      source: {
        type: DataTypes.TEXT,
      },

      current_stage: {
        type: DataTypes.ENUM,

        values: ['Applied', 'Interviewing', 'Offered', 'Hired'],
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  candidates.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    db.candidates.hasMany(db.applications, {
      as: 'applications_candidate',
      foreignKey: {
        name: 'candidateId',
      },
      constraints: false,
    });

    //end loop

    db.candidates.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });

    db.candidates.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.candidates.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return candidates;
};
